<?php

use Office365\PHP\Client\Runtime\Auth\AuthenticationContext;
use Office365\PHP\Client\SharePoint\ClientContext;
use Office365\PHP\Client\Runtime\ClientRuntimeContext;
use Office365\PHP\Client\SharePoint\SPList;
require_once './vendor/composer/bootstrap.php';
global $Settings;



function cvjs_downloadSharepointFileList($documentLibrary, $settingsUrl, $settingsUser, $settingsPwd, $settingRest, $drawingUrl){

try {

    $authCtx = new AuthenticationContext($settingsUrl);
    $authCtx->acquireTokenForUser($settingsUser,$settingsPwd);
    $ctx = new ClientContext($settingsUrl,$authCtx);
	$restUrl = $settingRest;

	$myURL = $restUrl . "/_api/web/Lists/getByTitle('" . $documentLibrary . "')/Files";


	//$myURL = $restUrl . "/_api/Web/GetFolderByServerRelativeUrl('" . $documentLibrary . "')/Files";


	//echo $myURL . "  ";

	// make random file

	$temp_file_name = rand();
	$random_file = "r" . $temp_file_name . ".txt";

	$fp = fopen( $random_file, 'w+');
	$options = new \Office365\PHP\Client\Runtime\Utilities\RequestOptions($myURL);

	$options->StreamHandle = $fp;
	$ctx->executeQueryDirect($options);
	fclose($fp);

	$list_content = file_get_contents($random_file, true);

	//echo $list_content;

	if (is_file($random_file))
		unlink($random_file); // delete file

	//echo $list_content . "XXXXX";
	//echo strpos($list_content, 'sharepoint') . " YY ";

	$i = -1;

	$file_list = "";
	while(strpos($list_content, '"Url":')>0) {
		$i++;

		//MS.FileServices.File
		$sub_file = substr($list_content, strpos($list_content, 'MS.FileServices.File')+7);

		//$sub1 = substr($list_content, strpos($list_content, '"Url":')+7);
		$sub1 = substr($sub_file, strpos($sub_file, '"Url":')+7);

		$sub2 = substr($sub1, 0, strpos($sub1, '}'));

		// last / in the string with drawings
		//$sub3 = substr($sub2, strrpos($sub2, '/')+1);

		// everything after document library location
		$sub3 = substr($sub2, strrpos($sub2, $documentLibrary )+ strlen($documentLibrary)+1);

		$sub3 = substr($sub3, 0, strlen($sub3)-1 );

		if ($i==0) $file_list = $sub3 . ";";
		if ($i>0)  $file_list = $file_list . $sub3 . ";";

		//echo " Y " . $sub3 . " X " ;
		$list_content = $sub1;
	}

	echo $file_list;

	//$json_list = json_decode($list_content);
	//echo $json_list['d']['results'][0]['__metadata']['Name'];
	//echo $json_list->{'results'}.size();

}
catch (Exception $e) {
    echo 'Error: ',  $e->getMessage(), "\n";
}

}



function  cvjs_downloadSharepointFile($sharepointfilename, $targetfile, $settingsUrl, $settingsUser, $settingsPwd, $settingRest, $drawingUrl){

try {
    $authCtx = new AuthenticationContext($settingsUrl);
    $authCtx->acquireTokenForUser($settingsUser,$settingsPwd);
    $ctx = new ClientContext($settingsUrl,$authCtx);
	$restUrl = $settingRest;

	$sharepointfilename = str_replace( " ", "%20", $sharepointfilename);
	$myURL = $restUrl . "/_api/Web/GetFileByServerRelativeUrl('" . $drawingUrl . $sharepointfilename . "')/\$value";

	//echo "WWWWWWWWWWWWWWW" . $myURL . "WWWWWWWWWWWW";

	downloadFileAsStream_CustomUrl($ctx, $myURL, $targetfile);

}
catch (Exception $e) {
    echo 'Error: ',  $e->getMessage(), "\n";
}
}



function downloadFileAsStream_CustomUrl(ClientRuntimeContext $ctx, $url, $targetFilePath) {

    $fp = fopen($targetFilePath, 'w+');

    $options = new \Office365\PHP\Client\Runtime\Utilities\RequestOptions($url);

    $options->StreamHandle = $fp;
    $ctx->executeQueryDirect($options);
    fclose($fp);

}



function downloadSharePointFileAsStream($ctx, $restUrl, $url, $targetFilePath) {

	try {

		$myURL = $restUrl . "/_api/Web/GetFileByServerRelativeUrl('" . $url . "')/\$value";


		echo " before, myUrl=". $myURL . "XXXXX";
		$fp = fopen($targetFilePath, 'w+');

		$options = new \Office365\PHP\Client\Runtime\Utilities\RequestOptions($myURL);

		$options->StreamHandle = $fp;
		$ctx->executeQueryDirect($options);
		fclose($fp);

		echo "after";

	}
	catch (Exception $e) {
		echo 'Error: ',  $e->getMessage(), "\n";
	}


}






function createSubFolder(ClientContext $ctx,$parentFolderUrl,$folderName){

    $files = $ctx->getWeb()->getFolderByServerRelativeUrl($parentFolderUrl)->getFiles();
    $ctx->load($files);
    $ctx->executeQuery();
    //print files info
    foreach ($files->getData() as $file) {
        print "File name: '{$file->getProperty("ServerRelativeUrl")}'\r\n";
    }


    $parentFolder = $ctx->getWeb()->getFolderByServerRelativeUrl($parentFolderUrl);
    $childFolder = $parentFolder->getFolders()->add($folderName);
    $ctx->executeQuery();
    print "Child folder {$childFolder->getProperty("ServerRelativeUrl")} has been created ";
}


function enumFolders(SPList $list)
{
    $ctx = $list->getContext();
    $folders = $list->getRootFolder()->getFolders();
    if($folders->getServerObjectIsNull() == true){  //determine whether folders has been loaded or not
        $ctx->load($folders);
        $ctx->executeQuery();
    }

    foreach ($folders->getData() as $folder) {
        print "File name: '{$folder->Name}'\r\n";
    }

}


function processFiles(SPList $list,$targetPath)
{
    $ctx = $list->getContext();
    $files = $list->getRootFolder()->getFiles();
    $ctx->load($files);
    $ctx->executeQuery();

    foreach ($files->getData() as $file) {
        print "File name: '{$file->Name}'\r\n";

        //checkoutFile($ctx,$file->ServerRelativeUrl);
        //checkinFile($ctx,$file->ServerRelativeUrl);
        //approveFile($ctx,$file->ServerRelativeUrl);
        $fileName = $targetPath . "/" . basename($file->ServerRelativeUrl);
        downloadFile($ctx,$file->ServerRelativeUrl,$fileName);
        //downloadFileAsStream($ctx,$file->ServerRelativeUrl,$fileName);
    }
}




function deleteFolder(ClientContext $ctx, $folderUrl){
    $folder = $ctx->getWeb()->getFolderByServerRelativeUrl($folderUrl);
    $folder->deleteObject();
    $ctx->executeQuery();
    print "Folder has been deleted\r\n";
}


function checkoutFile(ClientContext $ctx, $fileUrl){
    $file = $ctx->getWeb()->getFileByServerRelativeUrl($fileUrl);
    $file->checkOut();
    $ctx->executeQuery();
    print "File has been checked out\r\n";
}


function checkinFile(ClientContext $ctx, $fileUrl){
    $file = $ctx->getWeb()->getFileByServerRelativeUrl($fileUrl);
    $file->checkIn('');
    $ctx->executeQuery();
    print "File has been checked in\r\n";
}

function approveFile(ClientContext $ctx, $fileUrl){
    $file = $ctx->getWeb()->getFileByServerRelativeUrl($fileUrl);
    $file->approve('');
    $ctx->executeQuery();
    print "File {$fileUrl} has been approved\r\n";
}

function uploadFiles($localPath, \Office365\PHP\Client\SharePoint\SPList $targetList){

    $ctx = $targetList->getContext();

    $searchPrefix = $localPath . '*.*';
    foreach(glob($searchPrefix) as $filename) {
        $fileCreationInformation = new \Office365\PHP\Client\SharePoint\FileCreationInformation();
        $fileCreationInformation->Content = file_get_contents($filename);
        $fileCreationInformation->Url = basename($filename);

        $uploadFile = $targetList->getRootFolder()->getFiles()->add($fileCreationInformation);
        $ctx->executeQuery();
        print "File {$uploadFile->getProperty('Name')} has been uploaded\r\n";

        $uploadFile->getListItemAllFields()->setProperty('Title',basename($filename));
        $uploadFile->getListItemAllFields()->update();
        $ctx->executeQuery();
    }


}


function uploadFileIntoFolder(ClientContext $ctx, $localPath, $targetFolderUrl)
{
    $fileName = basename($localPath);
    $fileCreationInformation = new \Office365\PHP\Client\SharePoint\FileCreationInformation();
    $fileCreationInformation->Content = file_get_contents($localPath);
    $fileCreationInformation->Url = $fileName;


    $uploadFile = $ctx->getWeb()->getFolderByServerRelativeUrl($targetFolderUrl)->getFiles()->add($fileCreationInformation);
    $ctx->executeQuery();
    print "File {$uploadFile->getProperty('ServerRelativeUrl')} has been uploaded\r\n";

    //$uploadFile->getListItemAllFields()->setProperty('Title', $fileName);
    //$uploadFile->getListItemAllFields()->update();
    //$ctx->executeQuery();
}

function saveFile(ClientContext $ctx, $sourceFilePath, $targetFileUrl)
{
    $fileContent = file_get_contents($sourceFilePath);
    Office365\PHP\Client\SharePoint\File::saveBinary($ctx,$targetFileUrl,$fileContent);
    print "File has been uploaded\r\n";
}


function downloadFile(ClientRuntimeContext $ctx, $fileUrl, $targetFilePath){

    $fileContent = Office365\PHP\Client\SharePoint\File::openBinary( $ctx, $fileUrl);
    file_put_contents($targetFilePath, $fileContent);
}

function downloadFileAsStream(ClientRuntimeContext $ctx, $fileUrl, $targetFilePath) {

    $fp = fopen($targetFilePath, 'w+');

    $url = $ctx->getServiceRootUrl() . "Web/GetFileByServerRelativeUrl('$fileUrl')";
    $options = new \Office365\PHP\Client\Runtime\Utilities\RequestOptions($url);

    //echo "options " . $options;

    $options->StreamHandle = $fp;
    $ctx->executeQueryDirect($options);
    fclose($fp);

    //print "File {$fileUrl} has been downloaded successfully\r\n";
}


function overwriteFileAsStream(ClientContext $ctx, $fileUrl, $sourceFilePath) {
    $fileUrl = rawurlencode($fileUrl);
    $fp = fopen($sourceFilePath, 'r');

    $url = $ctx->getServiceRootUrl() . "web/getfilebyserverrelativeurl('$fileUrl')/\$value";
    $options = new \Office365\PHP\Client\Runtime\Utilities\RequestOptions($url);
    $options->Method = \Office365\PHP\Client\Runtime\HttpMethod::Post;
    $options->addCustomHeader('X-HTTP-Method','PUT');
    $ctx->ensureFormDigest($options);
    $options->StreamHandle = $fp;
    $options->addCustomHeader("content-length", filesize($sourceFilePath));

    $ctx->executeQueryDirect($options);
    fclose($fp);
    print "File {$fileUrl} has been uploaded successfully\r\n";
}
